package net.wanji.opt.service;

import net.wanji.databus.bo.CrossIdBO;
import net.wanji.databus.vo.GreenwaveListVO;
import net.wanji.opt.bo.*;
import net.wanji.opt.dto.trend.AbnormalCrossListDTO;
import net.wanji.opt.dto.trend.GreenwaveListDTO;
import net.wanji.opt.vo.*;

import java.text.ParseException;
import java.util.Date;
import java.util.List;

/**
 * @date 2023/1/12 15:12
 * @desc 态势监测接口服务
 */
public interface TrendService {

    List<GreenwaveListVO> greenwaveList(GreenwaveListDTO greenwaveListDTO);

    GreenwaveStats buildGreenwaveStats(List<GreenwaveListVO> greenwaveListVOList);

    AbnormalCrossVO abnormalCrossList(AbnormalCrossListDTO abnormalCrossListDTO);

    AbnormalCrossDetailVO abnormalCrossDetail(CrossIdBO crossIdBO);

    List<EventAlarmVO> eventAlarm(Date todayTime) throws ParseException;

    List<GreenWaveCrossMonitorVO> greenwaveCrossMonitor(GreenwaveIdBO greenwaveIdBO);

    List<GreenwaveRunMonitorVO> greenwaveRunMonitor(GreenwaveIdBO greenwaveIdBO);

    GreenwaveDetailVO greenwaveDetail(GreenwaveDetailBO greenwaveDetailBO);

    List<GreenwaveCrossMetricsVO> greenwaveCrossMetrics(GreenwaveIdAndTimeStampBO greenwaveIdAndTimeStampBO);

    void saveGreenwaveStrategy(SaveGreenwaveStrategyBO saveGreenwaveStrategyBO);

    GreenwaveDetailVO currentGreenwaveDetail(GreenwaveIdBO bo) throws ParseException;

    CountRealTimeVO countRealTime(String crossId) throws Exception;

    TableQueryVO tableQuery(CrossIdAndTimeSpanBO crossIdAndTimeSpanBO) throws Exception;

    TableQueryVO tableRealTime(CrossIdAndIsFirstBO crossIdAndIsFirstBO) throws Exception;

    OptTypeVO optType(CrossIdBO crossIdBO);
}
